﻿//////////////////////////////////////////////
// ToneMappingEffect.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
	class Texture ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../Dll/DllDefines.h"

#include "../Effect.h"

#include "ToneMappingEffectInfo.h"

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT ToneMappingEffect final : public Effect
	{
		private :

			// Attributes
			// Program
			nkGraphics::Program* _program ;
			ToneMappingEffectInfo _programInfo ;

			// Info
			ToneMappingEffectInfo _info ;

		private :

			// Functions
			// Program
			bool _prepareProgram () ;

			// Shader
			bool _prepareShader () ;

		public :

			// Constructor, destructor
			ToneMappingEffect () ;
			~ToneMappingEffect () ;

			// Getters
			virtual EFFECT_TYPE getType () const override ;
			nkGraphics::Texture* getSourceTexture () const ;

			// Setters
			void setSourceTexture (nkGraphics::Texture* value) ;

			// Load
			virtual bool load () override ;
			virtual void unload () override ;
	} ;
}