﻿//////////////////////////////////////////////
// ToneMappingProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Utils/ProgramTracker.h"

#include "ToneMappingEffectInfo.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <unordered_map>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct ToneMappingProgramIdGenerator
	{
		static unsigned long long generate (const ToneMappingEffectInfo& info) ;
	} ;

	struct ToneMappingProgramNameGenerator
	{
		constexpr static const char* name = "NILKINS_TONE_PROGRAM_" ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class ToneMappingProgramTracker final : public ProgramTracker<ToneMappingEffectInfo, ToneMappingProgramIdGenerator, ToneMappingProgramNameGenerator>, public nkCommon::SingletonClass<ToneMappingProgramTracker>
	{
		friend class SingletonClass<ToneMappingProgramTracker> ;

		private :

			// Functions
			// Constructor, destructor
			ToneMappingProgramTracker () ;
			~ToneMappingProgramTracker () ;
	} ;
}