﻿//////////////////////////////////////////////
// NodeWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkExportWrap
{
	class DLL_ASTRAEUS_EXPORT NodeWrapper final
	{
		private :

			NodeWrapper () = delete ;
			~NodeWrapper () = delete ;

		public :

			// Mise en place environnement
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks qui seront appelés suivant les fonctions
			// Construction / destruction
			static void* constructor (const nkScripts::DataStack& stack) ;
			static void destructor (void* toDestroy) ;
			// Getters
			static nkScripts::OutputValue getString (void* node) ;
			static nkScripts::OutputValue getInt (void* node) ;
			static nkScripts::OutputValue getFloat (void* node) ;
			static nkScripts::OutputValue getDouble (void* node) ;
			static nkScripts::OutputValue getBool (void* node) ;
			static nkScripts::OutputValue getNodeNature (void* node) ;
			static nkScripts::OutputValue getNodeValueType (void* node) ;
			static nkScripts::OutputValue getArraySize (void* node) ;
			static nkScripts::OutputValue isValueTypeNumber (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getArrayElement (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getMemberValue (const nkScripts::DataStack& stack) ;
			// Setters
			static void setString (const nkScripts::DataStack& stack) ;
			static void setInt (const nkScripts::DataStack& stack) ;
			static void setFloat (const nkScripts::DataStack& stack) ;
			static void setDouble (const nkScripts::DataStack& stack) ;
			static void setBool (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue addElement (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue addMember (const nkScripts::DataStack& stack) ;
	} ;
}