﻿//////////////////////////////////////////////
// Frustum.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkMaths
{
	class Matrix ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

// nkMaths
#include <NilkinsMaths/Algebra/Vector.h>

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT Frustum final
	{
		private :
		
			// Attributs
			// Les plans le constituant
			nkMaths::Vector _planes [6] ;
			
		public :
		
			// Constructeur, destructeur
			Frustum () ;
			Frustum (const Frustum& other) ;
			~Frustum () ;

			// Construction des plans
			void buildFrustum (const nkMaths::Matrix& viewMat, const nkMaths::Matrix& projMat) ;

			// Getters
			const nkMaths::Vector& getPlane (unsigned int index) const ;
	} ;
}