﻿//////////////////////////////////////////////
// GlVersion.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// Standards
#include <string_view>

/// Class ------------------------------------

namespace nkGraphics::gles
{
	enum class GLES_RENDERER_VERSION
	{
		GLES_RENDERER_UNKNOWN = 0,
		GLES_RENDERER_1_X,
		GLES_RENDERER_2_X,
		GLES_RENDERER_3_0,
		GLES_RENDERER_3_1,
		GLES_RENDERER_3_2,
		GLES_RENDERER_3_3,
		GLES_RENDERER_4_0,
		GLES_RENDERER_4_1,
		GLES_RENDERER_4_2,
		GLES_RENDERER_4_3,
		GLES_RENDERER_4_4,
		GLES_RENDERER_4_5,
		GLES_RENDERER_4_6
	} ;

	class GlesRendererVersionUtils final
	{
		private :

			// Constructor, destructor
			GlesRendererVersionUtils () = delete ;
			~GlesRendererVersionUtils () = delete ;

		public :

			// Utils
			static std::string_view enumToString (GLES_RENDERER_VERSION value) ;
	} ;
}