﻿//////////////////////////////////////////////
// InputSystem.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class BaseKeyHandler ;
	class BaseMouseHandler ;
	class Camera ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT InputSystem
	{
		private :
		
			// Attributs
			// Handler clavier et souris (pour le moment, global. Ptet faire un système plus générique par la suite)
			BaseKeyHandler* _keyHandler ;
			BaseMouseHandler* _mouseHandler ;

			// Si on etait focus auparavant
			bool _wasFocused ;
		
		public :
		
			// Constructeur, destructeur
			InputSystem () ;
			~InputSystem () ;

			// Lancement
			bool initialize () ;

			// Getter
			BaseKeyHandler* getKeyHandler () const ;
			BaseMouseHandler* getMouseHandler () const ;

			// Setters
			void setKeyHandler (BaseKeyHandler* handler) ;
			void setMouseHandler (BaseMouseHandler* handler) ;

			// Update
			void update () ;
	} ;
}