﻿//////////////////////////////////////////////
// KeyboardDeviceManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkInputs
{
	class KeyboardDevice ;
}

/// Includes ---------------------------------

// nkInputs
#include "../../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <unordered_map>

/// Class ------------------------------------

namespace nkInputs
{
	class DLL_INPUTS_EXPORT KeyboardDeviceManager final : public nkCommon::SingletonClass<KeyboardDeviceManager>
	{
		friend class nkCommon::SingletonClass<KeyboardDeviceManager> ;

		private :

			// Attributes
			// Memory
			std::unordered_map<std::string, KeyboardDevice*> _devices ;

		private :

			// Functions
			// Constructor, destructor
			KeyboardDeviceManager () ;
			~KeyboardDeviceManager () ;

		public :

			// Memory Management
			KeyboardDevice* createOrRetrieve (const std::string_view& name) ;
			KeyboardDevice* get (const std::string_view& name) ;
			void rename (const std::string_view& currentName, const std::string_view& newName) ;
			void erase (const std::string_view& name) ;
	} ;
}