//////////////////////////////////////////////
// FontManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

struct HFONT__ ;
typedef HFONT__* HFONT ;

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"
	
// Common
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <string>
#include <unordered_map>

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT FontManager final : public nkCommon::SingletonClass<FontManager>
	{
		friend class nkCommon::SingletonClass<FontManager> ;

		private :
				
			// Constructeur, destructeur
			FontManager () ;
			~FontManager () ;

			// Attributs
			// Map des fonts que nous avons
			std::unordered_map<std::string, HFONT> _fonts ;
		
		public :
		
			// Ajout
			void addFont (const char* name, HFONT font) ;

			// Retrait
			HFONT getFont (const char* name) ;
			HFONT getDefaultFont () ;
	} ;
}